/* cmd_neonhelp_delete.c - NeonServ v5.6
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_neonhelp.h"

/*
* argv[0]   suppid
*/

CMD_BIND(neonhelp_cmd_delete) {
    //check permissions
    MYSQL_RES *res;
    MYSQL_ROW row, row2;
    int caccess = 0;
    printf_mysql_query("SELECT `helpserv_support`, `helpserv_public`, `helpserv_intern` FROM `helpserv_settings` WHERE `helpserv_botid` = '%d'", client->clientid);
    res = mysql_use();
    if (!(row = mysql_fetch_row(res))) return;
    //check if the user is a supporter (access in the support channel)
    if((user->flags & USERFLAG_ISAUTHED)) {
        int userid;
        if(user->flags & USERFLAG_HAS_USERID)
            userid = user->user_id;
        else {
            printf_mysql_query("SELECT `user_id` FROM `users` WHERE `user_user` = '%s'", escape_string(user->auth));
            res = mysql_use();
            if ((row2 = mysql_fetch_row(res)) != NULL) {
                userid = atoi(row2[0]);
                user->user_id = userid;
                user->flags |= USERFLAG_HAS_USERID;
            } else
                userid = 0;
        }
        printf_mysql_query("SELECT `chanuser_access`, `chanuser_flags` FROM `chanusers` LEFT JOIN `channels` ON `chanuser_cid` = `channel_id` WHERE `chanuser_uid` = '%d' AND `channel_name` = '%s'", userid, escape_string(row[0]));
        res = mysql_use();
        if ((row2 = mysql_fetch_row(res)) != NULL) {
            int cflags = atoi(row2[1]);
            if(!(cflags & DB_CHANUSER_SUSPENDED))
                caccess = atoi(row2[0]);
        }
    }
    if(!caccess) {
        reply(textclient, user, "MODCMD_ACCESS_DENIED");
        return;
    }
    if(!(client->flags & SOCKET_HAVE_HELPNODE) || client->botclass_helpnode == NULL) {
        reply(textclient, user, "NH_NEXT_NONE");
        return;
    }
    struct NeonHelpNode *helpnode, *prev_helpnode = NULL;
    for(helpnode = client->botclass_helpnode; helpnode; helpnode = helpnode->next) {
        if(atoi(argv[0]) == helpnode->suppid)
            break;
        else
            prev_helpnode = helpnode;
    }
    if(!helpnode) {
        reply(textclient, user, "NH_NEXT_NOT_FOUND");
        return;
    }
    if(helpnode->status == 1) {
        struct ChanNode *support, *public;
        support = getChanByName(row[0]);
        public = (row[1] ? getChanByName(row[1]) : NULL);
        if(isUserOnChan(helpnode->user, support)) {
            if(public)
                putsock(client, "KICK %s %s :your request has been closed", support->name, helpnode->user->nick);
            else
                putsock(client, "MODE %s -v %s", support->name, helpnode->user->nick);
        } else {
            putsock(client, "MODE %s -i", support->name); //clear invite list
            if(isModeSet(support->modes, 'i'))
                putsock(client, "MODE %s +i", support->name);
            neonhelp_invite_active_requests(client, support, public, helpnode->user);
        }
    }
    if(prev_helpnode)
        prev_helpnode->next = helpnode->next;
    else
        client->botclass_helpnode = helpnode->next;
    reply(textclient, user, "NH_DELETED_STAFF", helpnode->suppid, helpnode->user->nick);
    neonhelp_destroy_support_request(client, helpnode, 1);
}
