/* cmd_neonserv.h - NeonServ v5.6
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */
#ifndef _cmd_neonserv_h
#define _cmd_neonserv_h
#include "../module.h"
#include "../botid.h"
#include "../../main.h"
#include "../../modcmd.h"
#include "../../IRCParser.h"
#include "../../IRCEvents.h"
#include "../../UserNode.h"
#include "../../ChanNode.h"
#include "../../ChanUser.h"
#include "../../ModeNode.h"
#include "../../BanNode.h"
#include "../../ClientSocket.h"
#include "../../mysqlConn.h"
#include "../../lang.h"
#include "../../HandleInfoHandler.h"
#include "../../WHOHandler.h"
#include "../../DBHelper.h"
#include "../../tools.h"
#include "../../timeq.h"
#include "../../version.h"
#include "../../EventLogger.h"
#include "../../bots.h"
#include "bot_NeonServ.h"
#include "../../ConfigParser.h"

void register_commands();

/* cmd_neonserv_unvisited.c */
void neonserv_cmd_unvisited_init();

CMD_BIND(neonserv_cmd_access);
CMD_BIND(neonserv_cmd_addban);
CMD_BIND(neonserv_cmd_addrank);
CMD_BIND(neonserv_cmd_addtimeban);
CMD_BIND(neonserv_cmd_adduser);
CMD_BIND(neonserv_cmd_assignrank);
CMD_BIND(neonserv_cmd_ban);
CMD_BIND(neonserv_cmd_bans);
CMD_BIND(neonserv_cmd_chanservsync);
CMD_BIND(neonserv_cmd_clvl);
CMD_BIND(neonserv_cmd_csuspend);
CMD_BIND(neonserv_cmd_cunsuspend);
CMD_BIND(neonserv_cmd_dehalfop);
CMD_BIND(neonserv_cmd_dehalfopall);
CMD_BIND(neonserv_cmd_delban);
CMD_BIND(neonserv_cmd_delme);
CMD_BIND(neonserv_cmd_delrank);
CMD_BIND(neonserv_cmd_deluser);
CMD_BIND(neonserv_cmd_deop);
CMD_BIND(neonserv_cmd_deopall);
CMD_BIND(neonserv_cmd_devoice);
CMD_BIND(neonserv_cmd_devoiceall);
CMD_BIND(neonserv_cmd_down);
CMD_BIND(neonserv_cmd_downall);
CMD_BIND(neonserv_cmd_events);
CMD_BIND(neonserv_cmd_giveowner);
CMD_BIND(neonserv_cmd_halfop);
CMD_BIND(neonserv_cmd_halfopall);
CMD_BIND(neonserv_cmd_help);
CMD_BIND(neonserv_cmd_info);
CMD_BIND(neonserv_cmd_invite);
CMD_BIND(neonserv_cmd_inviteme);
CMD_BIND(neonserv_cmd_kick);
CMD_BIND(neonserv_cmd_kickban);
CMD_BIND(neonserv_cmd_listrank);
CMD_BIND(neonserv_cmd_mdeluser);
CMD_BIND(neonserv_cmd_mode);
CMD_BIND(neonserv_cmd_myaccess);
CMD_BIND(neonserv_cmd_nicklist);
CMD_BIND(neonserv_cmd_noregister);
CMD_BIND(neonserv_cmd_op);
CMD_BIND(neonserv_cmd_opall);
CMD_BIND(neonserv_cmd_oplog);
CMD_BIND(neonserv_cmd_peek);
CMD_BIND(neonserv_cmd_recover);
CMD_BIND(neonserv_cmd_rename);
CMD_BIND(neonserv_cmd_resync);
CMD_BIND(neonserv_cmd_search);
CMD_BIND(neonserv_cmd_set);
CMD_BIND(neonserv_cmd_setrank);
CMD_BIND(neonserv_cmd_suspend);
CMD_BIND(neonserv_cmd_topic);
CMD_BIND(neonserv_cmd_trace);
CMD_BIND(neonserv_cmd_trim);
CMD_BIND(neonserv_cmd_unban);
CMD_BIND(neonserv_cmd_unbanall);
CMD_BIND(neonserv_cmd_unbanme);
CMD_BIND(neonserv_cmd_unsuspend);
CMD_BIND(neonserv_cmd_unvisited);
CMD_BIND(neonserv_cmd_up);
CMD_BIND(neonserv_cmd_upall);
CMD_BIND(neonserv_cmd_users);
CMD_BIND(neonserv_cmd_uset);
CMD_BIND(neonserv_cmd_voice);
CMD_BIND(neonserv_cmd_voiceall);
CMD_BIND(neonserv_cmd_wipeinfo);

#endif